; ------------------------------------------------------------------------------------
; LinkedList
; LinkedList Wrapper auf PB - Listen
; ------------------------------------------------------------------------------------

; ------------------------------------------------------------------------------------
; Strukturen
; ------------------------------------------------------------------------------------


Structure LL_Data
  List Entry.i()
EndStructure

Global NewList _LLHolder.LL_Data()

; ------------------------------------------------------------------------------------
;- Erstellen, Hinzufgen, Lschen
; ------------------------------------------------------------------------------------

Procedure LL_New()
  AddElement(_LLHolder())
  ProcedureReturn _LLHolder()
EndProcedure

Macro LL_Add(_LL)
  AddElement(_LL#\Entry())
EndMacro

Macro LL_Delete(_LL)
  DeleteElement(_LL#\Entry())
EndMacro

Macro LL_Free(_LL)
  ChangeCurrentElement(_LLHolder(), _LL)
  FreeList(_LLHolder()\Entry())
  DeleteElement(_LLHolder())
EndMacro

Macro LL_Count(_LL)
  ListSize(_LL#\Entry())
EndMacro

; ------------------------------------------------------------------------------------
;- Steuerung
; ------------------------------------------------------------------------------------

Macro LL_Next(_LL)
  NextElement(_LL#\Entry())
EndMacro

Macro LL_Prev(_LL)
  PreviousElement(_LL#\Entry())
EndMacro

Macro LL_Reset(_LL)
  ResetList(_LL#\Entry())
EndMacro

Macro LL_First(_LL)
  FirstElement(_LL#\Entry())
EndMacro

Macro LL_Last(_LL)
  LastElement(_LL#\Entry())
EndMacro

Macro LL_GetEntry(_LL)
  @_LL#\Entry()
EndMacro

Macro LL_SetEntry(_LL, _Entry)
  ChangeCurrentElement(_LL#\Entry(), _Entry)
EndMacro

Procedure LL_SwitchNext(*LL.LL_Data)
  Protected tElement = @*LL\Entry()
  NextElement(*LL\Entry())
  SwapElements(*LL\Entry(), tElement, @*LL\Entry())
EndProcedure

Procedure LL_SwitchPrev(*LL.LL_Data)
  Protected tElement = @*LL\Entry()
  PreviousElement(*LL\Entry())
  SwapElements(*LL\Entry(), tElement, @*LL\Entry())
EndProcedure

; ------------------------------------------------------------------------------------
;- Lesen & Setzen
; ------------------------------------------------------------------------------------

Macro LL_Get(_LL)
  _LL#\Entry()
EndMacro

Macro LL_Set(_LL, Val)
  _LL#\Entry() = Val
EndMacro

; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 2
; Folding = ---
; EnableXP
; CPU = 1
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant